#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <string>
#include <vector>
#include <iostream>
#include <memory>
#include <functional>
using namespace std;
#pragma comment(lib,"ws2_32.lib")
#pragma comment(lib,"winmm.lib")
#pragma comment(linker,"\"/manifestdependency:type='win32' \
name='Microsoft.Windows.Common-Controls' version='6.0.0.0' \
processorArchitecture='*' publicKeyToken='6595b64144ccf1df' language='*'\"")

typedef HRESULT(__stdcall* IGiveHelp)(HWND , HICON , unsigned short , std::function <HRESULT(vector<char>& , string& , int& )> , const wchar_t* , int , vector<tuple<string, unsigned short>>* );



// Main
int main(int argc,char** argv)
	{
	WSADATA wData;
	WSAStartup(MAKEWORD(2, 2), &wData);
	// COM initialization
	CoInitializeEx(0, COINIT_APARTMENTTHREADED);

	int c1 = ShowCursor(false);
	int c2 = ShowCursor(true);

	// Load the DLL
#ifdef _WIN64
		HINSTANCE hDLL = LoadLibrary(L"hmn64.dll");
#else
	HINSTANCE hDLL = LoadLibrary(L"hmn32.dll");
#endif
	if (!hDLL)
		{
		std::cout << "Error, HMN DLL cannot be found." << endl;
		return 0;
		}

	// Get ports to use
	HICON hIcon = LoadIcon(0, IDI_QUESTION);
	unsigned short Port1 = 7004;
	unsigned short Port2 = 7005;

	if (argc >= 2)
		Port1 = (unsigned short)atoi(argv[1]);
	else
		{
		std::cout << "Enter negotiation port: ";
		std::cin >> Port1;
		}
	if (argc >= 3)
		Port2 = (unsigned short)atoi(argv[2]);
	else
		{
		std::cout << "Enter connection port: ";
		std::cin >> Port2;
		}
	if (Port1 == 0 || Port2 == 0 || Port1 == Port2)
		{
		Port1 = 7004;
		Port2 = 7005;
		}



	// Try the server
	auto fa = [&](vector<char>& ticket, string& ip, int& port) -> HRESULT
		{
		UNREFERENCED_PARAMETER(ticket);
		port = Port2;
		ip.clear();
		return S_OK;
		};
	vector<tuple<string, unsigned short>> Redirects;
	IGiveHelp g = (IGiveHelp)GetProcAddress(hDLL, "IGiveHelp");
	if (!g)
		return 0;
	auto rs = g(nullptr,hIcon, Port1, fa,L"Joe Smith",1,&Redirects);
	if (FAILED(rs))
		std::cout << "Operation failed." << endl;
	else
		std::cout << "Operation completed." << endl;

	// Free
	FreeLibrary(hDLL);
	return 0;
	}
